[![Build Status](https://travis-ci.org/billmclean/GaussQuadrature.jl.svg?branch=master)](https://travis-ci.org/billmclean/GaussQuadrature.jl)

GaussQuadrature.jl
==================

Julia package to compute points and weights for Gauss quadrature rules
using the Golub-Welsch algorithm.

Handles the classical Legendre, Chebyshev, Jacobi, Laguerre and Hermite 
weights, as well as a logarithmic weight function.  In fact, the 
Gauss rule is available for any custom weight function such that the 
coefficients are known for the three-term recurrence relation satisfied 
by the associated orthogonal polynomials.  The modified Chebyshev 
algorithm is provided to determine these coefficients from the modified 
moments of the weight function.

The Lobatto and Radau variants of all these rules are also provided by
appropriate choice of the `endpt` argument: `neither` (the default), 
`both`, `left` or `right`.

For example, to obtain a plain 5-point Gauss-Legendre rule with weight
function `w(x)=1` on the interval `-1 < x < -1` do

    julia> using GaussQuadrature
    julia> x, w = legendre(5)

whereas for the Lobatto version do

    julia> x, w = legendre(5, both)

The package supports `BigFloat`s; for example,

    julia> x, w = legendre(BigFloat, 5)

gives a plain 5-point Gauss-Legendre rule accurate to about 75 significant
figures.

Read the initial comments in the src/GaussQuadrature.jl module
for full details, or read the help documentation for the individual
functions called `legendre`, `chebyshev`, `jacobi`, `laguerre`, `hermite`, 
`logweight` and `custom_gauss_rule`.

using LinearAlgebra

const n = 8
a, b = legendre_coefs(Float64, n)

Tn = SymTridiagonal(copy(a), b[2:n])
F = eigen(Tn)

v = zeros(n)
special_eigenproblem!(a, b, v, 30)

idx = sortperm(a)
@test a[idx] ≈ F.values
@test abs.(v[idx]) ≈ abs.(F.vectors[1,:])

using GaussQuadrature
using PyPlot

#x = collect(range(0; stop=1, length=201))
x = range(0; stop=1, length=201)
const n = 5

a, b = shifted_legendre_coefs(Float64, n)
p = orthonormal_poly(x, a, b)
grid(true)

figure(1)
plot(x, p)
const r = 0
α, β = logweight_coefs(Float64, n+1, r)
q = orthonormal_poly(x, α[1:n], β)
title("Orthonormal shifted Legendre polynomials")

figure(2)
plot(x, q)
grid(true)
s = "Orthonormal polymials with weight \$\\log x^{-1}\$"
title(latexstring(s))

using GaussQuadrature
using SpecialFunctions: besseli
using Test

include("test_eigen.jl")
include("test_legendre.jl")
include("test_chebyshev.jl")
include("test_jacobi.jl")
include("test_laguerre.jl")
include("test_hermite.jl")
include("test_logweight.jl")

export legendre_coeff, chebyshev_coeff, jacobi_coeff
export laguerre_coeff, hermite_coeff

function depwarn(old, new)
    msg = """
    $old will be removed in GaussQuadrature 0.4.
    Use $new instead."""
    warn(msg)
end

function legendre_coeff{T<:AbstractFloat}(::Type{T},
                       n::Integer, endpt::EndPt)
    depwarn("legendre_coeff", "legendre_coefs")
    μ0 = convert(T, 2.0)
    a = zeros(T, n)
    b = zeros(T, n)
    for i = 1:n
        b[i] = i / sqrt(convert(T, 4*i^2-1))
    end
    return a, b, μ0
end

function chebyshev_coeff{T<:AbstractFloat}(::Type{T},
                        n::Integer, kind::Integer, endpt::EndPt)
    depwarn("chebyshev_coeff", "chebyshev_coefs")
    muzero = convert(T, pi)
    half = convert(T, 0.5)
    a = zeros(T, n)
    b = fill(half, n)
    if kind == 1
        b[1] = sqrt(half)
    elseif kind == 2
        muzero /= 2
    else
        error("Unsupported value for kind")
    end
    return a, b, muzero
end

function jacobi_coeff{T<:AbstractFloat}(n::Integer, alpha::T,
                                        beta::T, endpt::EndPt)
    depwarn("jacobi_coeff", "jacobi_coefs")
    ab = alpha + beta
    i = 2
    abi = ab + 2
    μ0 = 2^(ab+1) * exp(
             lgamma(alpha+1) + lgamma(beta+1) - lgamma(abi) )
    a = zeros(T, n)
    b = zeros(T, n)
    a[1] = ( beta - alpha ) / abi
    b[1] = sqrt( 4*(alpha+1)*(beta+1) / ( (ab+3)*abi*abi ) )
    a2b2 = beta*beta - alpha*alpha
    for i = 2:n
        abi = ab + 2i
        a[i] = a2b2 / ( (abi-2)*abi )
        b[i] = sqrt( 4i*(alpha+i)*(beta+i)*(ab+i) /
                     ( (abi*abi-1)*abi*abi ) )
    end
    return a, b, μ0
end

function laguerre_coeff{T<:AbstractFloat}(n::Integer, alpha::T,
                                          endpt::EndPt)
    depwarn("laguerre_coeff", "laguerre_coefs")
    @assert endpt in [neither, left]
    μ0 = gamma(alpha+1)
    a = zeros(T, n)
    b = zeros(T, n)
    for i = 1:n
        a[i] = 2i - 1 + alpha
        b[i] = sqrt( i*(alpha+i) )
    end
    return a, b, μ0
end

function hermite_coeff{T<:AbstractFloat}(::Type{T}, n::Integer)
    depwarn("hermite_coeff", "hermite_coefs")
    μ0 = sqrt(convert(T, pi))
    a = zeros(T, n)
    b = zeros(T, n)
    for i = 1:n
        iT = convert(T, i)
        b[i] = sqrt(iT/2)
    end
    return a, b, μ0
end

function custom_gauss_rule{T<:AbstractFloat}(lo::T, hi::T,
         a::Array{T,1}, b::Array{T,1}, μ0::T, endpt::EndPt,
         maxits::Integer=maxiterations[T])
    #
    # On entry:
    #
    # a, b hold the coefficients (as given, for instance, by
    # legendre_coeff) in the three-term recurrence relation
    # for the orthonormal polynomials p_0, p_1, p_2, ... , that is,
    #
    #    b[j] p (x) = (x-a[j]) p   (x) - b[j-1] p   (x).
    #          j                j-1              j-2
    #
    # μ0 holds the zeroth moment of the weight function, that is
    #
    #          / hi
    #         |
    #    μ0 = | w(x) dx.
    #         |
    #         / lo
    #
    # On return:
    #
    # x, w hold the points and weights.
    #
    warn("This method will be removed in GaussQuadrature 0.4")
    n = length(a)
    @assert length(b) == n
    if endpt == left
        if n == 1
            a[1] = lo
        else
            a[n] = solve(n, lo, a, b) * b[n-1]^2 + lo
        end
    elseif endpt == right
        if n == 1
            a[1] = hi
        else
            a[n] = solve(n, hi, a, b) * b[n-1]^2 + hi
        end
    elseif endpt == both
        if n == 1
            error("Must have at least two points for both ends.")
        end
        g = solve(n, lo, a, b)
        t1 = ( hi - lo ) / ( g - solve(n, hi, a, b) )
        b[n-1] = sqrt(t1)
        a[n] = lo + g * t1
    end
    w = zero(a)
    steig!(a, b, w, maxits)
    for i = 1:n
        w[i] = μ0 * w[i]^2
    end
    idx = sortperm(a)
    return a[idx], w[idx]
end

function steig!{T<:AbstractFloat}(d::Array{T,1}, e::Array{T,1}, 
                                  z::Array{T,1}, maxits::Integer)
    #
    # Finds the eigenvalues and first components of the normalised
    # eigenvectors of a symmetric tridiagonal matrix by the implicit
    # QL method.
    #
    # d[i]   On entry, holds the ith diagonal entry of the matrix. 
    #        On exit, holds the ith eigenvalue.
    #
    # e[i]   On entry, holds the [i+1,i] entry of the matrix for
    #        i = 1, 2, ..., n-1.  (The value of e[n] is not used.)
    #        On exit, e is overwritten.
    #
    # z[i]   On exit, holds the first component of the ith normalised
    #        eigenvector associated with d[i].
    #
    # maxits The maximum number of QL iterations.
    #
    # Martin and Wilkinson, Numer. Math. 12: 377-383 (1968).
    # Dubrulle, Numer. Math. 15: 450 (1970).
    # Handbook for Automatic Computation, Vol ii, Linear Algebra, 
    #        pp. 241-248, 1971.
    #
    # This is a modified version of the Eispack routine imtql2.
    #
    n = length(z)
    z[1] = 1
    z[2:n] = 0
    e[n] = 0

    if n == 1 # Nothing to do for a 1x1 matrix.
        return
    end
    for l = 1:n
        for j = 1:maxits
            # Look for small off-diagonal elements.
            m = n
            for i = l:n-1
                if abs(e[i]) <= eps(T) * ( abs(d[i]) + abs(d[i+1]) )
                    m = i
                    break   
                end
            end
            p = d[l]
            if m == l
                continue
            end
            if j == maxits
                msg = @sprintf("No convergence after %d iterations", j)
                msg *= " (try increasing maxits)"
                error(msg)
            end
            # Form shift
            g = ( d[l+1] - p ) / ( 2 * e[l] )
            r = hypot(g, one(T))
            g = d[m] - p + e[l] / ( g + copysign(r, g) )
            s = one(T)
            c = one(T)
            p = zero(T)
            for i = m-1:-1:l
                f = s * e[i]
                b = c * e[i]
                if abs(f) <  abs(g)
                    s = f / g
                    r = hypot(s, one(T))
                    e[i+1] = g * r
                    c = one(T) / r
                    s *= c
                else
                    c = g / f
                    r = hypot(c, one(T))
                    e[i+1] = f * r
                    s = one(T) / r
                    c *= s
                end 
                g = d[i+1] - p
                r = ( d[i] - g ) * s + 2 * c * b
                p = s * r
                d[i+1] = g + p
                g = c * r - b
                # Form first component of vector.
                f = z[i+1]
                z[i+1] = s * z[i] + c * f
                z[i]   = c * z[i] - s * f
            end # loop over i
            d[l] -= p
            e[l] = g
            e[m] = zero(T)
        end # loop over j
    end # loop over l
end

function orthonormal_poly{T<:AbstractFloat}(x::Array{T,1},
                         a::Array{T,1}, b::Array{T,1}, μ0::T)
    # p[i,j] = value at x[i] of orthonormal polynomial of degree j-1.
    m = length(x)
    n = length(a)
    p = zeros(T, m, n+1)
    c = one(T) / sqrt(μ0)
    rb = one(T) / b[1]
    for i = 1:m
        p[i,1] = c
        p[i,2] = rb * ( x[i] - a[1] ) * c
    end
    for j = 2:n
       rb = one(T) / b[j]
       for i = 1:m
           p[i,j+1] = rb * ( (x[i]-a[j]) * p[i,j]
                                - b[j-1] * p[i,j-1] )
       end
    end
    return p
end

correct = sqrt(π) * exp(-1/4) / 2
f(x) = sin(sqrt(x)) / sqrt(x)
α = 1/2

let
    x, w = laguerre(10, α)
    Q = sum(w .* f.(x))
    @test Q ≈ correct
end

let
    x, w = laguerre(10, α, left)
    X = x[2:end]
    W = w[2:end]
    Q = w[1] + sum(W .* f.(X))
    @test Q ≈ correct
end

module GaussQuadrature

using SpecialFunctions: gamma, loggamma

# October 2013 by Bill McLean, School of Maths and Stats,
# The University of New South Wales.
#
# Based on earlier Fortran codes
#
# gaussq.f original version 20 Jan 1975 from Stanford
# gaussq.f modified 21 Dec by Eric Grosse
# gaussquad.f95 Nov 2005 by Bill Mclean
#
# This module provides functions to compute the abscissae x[j] and 
# weights w[j] for the classical Gauss quadrature rules, including 
# the Radau and Lobatto variants.  Thus, the sum
#
#           n
#           ∑  w[j] f(x[j])
#          j=1
#
# approximates
#
#           hi
#          ∫  f(x) w(x) dx
#          lo
#
# where the weight function w(x) and interval lo < x < hi are as shown
# in the table below.
#
# Name                      Interval     Weight Function
#
# Legendre                 -1 < x < 1          1      
# Chebyshev (first kind)   -1 < x < 1     1 / sqrt(1-x²)        
# Chebyshev (second kind)  -1 < x < 1       sqrt(1-x²)          
# Jacobi                   -1 < x < 1     (1-x)ᵅ (1+x)ᵝ  
# Laguerre                  0 < x < ∞     xᵅ exp(-x)
# Hermite                  -∞ < x < ∞      exp(-x²)
#
# In addition to these classical rules, the module generates Gauss rules
# for logarithmic weights of the form
#
#    w(x) = x^ρ log(1/x)   for 0 < x < 1.
#
# For the Jacobi and Laguerre rules we require α > -1 and
# β > -1, so that the weight function is integrable.  Likewise, for
# log weight we require ρ > -1.
#
# Use the endpt argument to include one or both of the end points
# of the interval of integration as an abscissa in the quadrature 
# rule, as follows.
# 
# endpt = neither   Default      lo < x[j] < hi, j = 1:n.
# endpt = left      Left Radau   lo = x[1] < x[j] < hi, j = 2:n.
# endpt = right     Right Radau  lo < x[j] < x[n] = hi, j = 1:n-1.
# endpt = both      Lobatto      lo = x[1] < x[j] < x[n] = hi, j = 2:n-1.
#
# These labels make up an enumeration of type EndPt.
#
# The code uses the Golub and Welsch algorithm, in which the abscissae
# x[j] are the eigenvalues of a symmetric tridiagonal matrix whose 
# entries depend on the coefficients in the 3-term recurrence relation
# for the othonormal polynomials generated by the weighted inner product.
#
# References:
#
#   1.  Golub, G. H., and Welsch, J. H., Calculation of Gaussian
#       quadrature rules, Mathematics of Computation 23 (April,
#       1969), pp. 221-230.
#   2.  Golub, G. H., Some modified matrix eigenvalue problems,
#       Siam Review 15 (april, 1973), pp. 318-334 (section 7).
#   3.  Stroud and Secrest, Gaussian Quadrature Formulas, Prentice-
#       Hall, Englewood Cliffs, N.J., 1966.

export neither, left, right, both
export legendre, legendre_coefs
export chebyshev, chebyshev_coefs
export jacobi, jacobi_coefs
export laguerre, laguerre_coefs
export hermite, hermite_coefs
export shifted_legendre_coefs
export logweight, logweight_coefs
export modified_moments, modified_chebyshev
export custom_gauss_rule, orthonormal_poly
export special_eigenproblem! 

# Enumeration type used to specify which endpoints of the integration
# interval should be included amongst the quadrature points: neither,
# left, right or both.
struct EndPt
    label :: Char
end

const neither = EndPt('N')
const left    = EndPt('L')
const right   = EndPt('R')
const both    = EndPt('B')

#include("to_be_removed.jl")

# Maximum number of QL iterations used by steig!.
# You might need to increase this.
maxiterations = Dict(Float32 => 30, Float64 => 30, BigFloat => 40)

"""
    x, w = legendre(T, n, endpt=neither)

Returns points `x` and weights `w` for the `n`-point Gauss-Legendre rule
for the interval `-1 < x < 1` with weight function `w(x) = 1`.

Use `endpt=left`, `right` or `both` for the left Radau, right Radau or
Lobatto rules, respectively.
"""
function legendre(::Type{T}, n::Integer, 
                  endpt::EndPt=neither) where {T<:AbstractFloat}
    @assert n ≥ 1
    a, b = legendre_coefs(T, n)
    return custom_gauss_rule(-one(T), one(T), a, b, endpt)
end

"""
Convenience function with type `T = Float64`:

    x, w = legendre(n, endpt=neither)
"""
legendre(n, endpt=neither) = legendre(Float64, n, endpt)

function legendre_coefs(::Type{T}, n::Integer) where {T<:AbstractFloat}
    a = zeros(T, n)
    b = zeros(T, n+1)
    b[1] = sqrt(convert(T, 2))
    for k = 2:n+1
        b[k] = (k-1) / sqrt(convert(T, (2k-1)*(2k-3)))
    end
    return a, b
end

"""
    x, w = chebyshev(T, n, kind=1, endpt=neither)

Returns points `x` and weights `w` for the `n`-point Gauss-Chebyshev rule
for the interval `-1 < x < 1` with weight function

    w(x) = 1 / sqrt(1-x²)   if kind=1
    w(x) = sqrt(1-x²)       if kind=2.

Use `endpt=left`, `right` or `both` for the left Radau, right Radau or
Lobatto rules, respectively.
"""
function chebyshev(::Type{T}, n::Integer, kind::Integer=1, 
                   endpt::EndPt=neither) where {T<:AbstractFloat}
    @assert n ≥ 1
    a, b = chebyshev_coefs(T, n, kind)
    return custom_gauss_rule(-one(T), one(T), a, b, endpt)
end

"""
Convenience function with type `T = Float64`:

    x, w = chebyshev(n, kind=1, endpt=neither)

"""
chebyshev(n, kind=1, endpt=neither) = chebyshev(Float64, n, kind, endpt)

function chebyshev_coefs(::Type{T}, n::Integer, 
                         kind::Integer) where {T<:AbstractFloat}
    half = convert(T, 1//2)
    a = zeros(T, n)
    b = fill(half, n+1)
    if kind == 1 
        b[1] = sqrt(convert(T, pi))
	if n >= 2
            b[2] = sqrt(half)
        end
    elseif kind == 2
        b[1] = sqrt(half * convert(T, pi))
    else
        error("Unsupported value for kind")
    end
    return a, b
end

"""
    x, w = jacobi(n, α, β, endpt=neither)

Returns points `x` and weights `w` for the `n`-point Gauss-Jacobi rule
for the interval `-1 < x < 1` with weight function

    w(x) = (1-x)ᵅ (1+x)ᵝ.

Use `endpt=left`, `right` or `both` for the left Radau, right Radau or
Lobatto rules, respectively.
"""
function jacobi(n::Integer, α::T, β::T, 
                endpt::EndPt=neither) where {T<:AbstractFloat}
    @assert n ≥ 1
    @assert α > -1.0 && β > -1.0
    a, b = jacobi_coefs(n, α, β)
    custom_gauss_rule(-one(T), one(T), a, b, endpt)
end

function jacobi_coefs(n::Integer, α::T, β::T) where {T<:AbstractFloat}
    a = zeros(T, n)
    b = zeros(T, n+1)
    ab = α + β
    abi = ab + 2
    b[1] = 2^((ab+1)/2) * exp(
             ( loggamma(α+1) + loggamma(β+1) - loggamma(abi) )/2 )
    a[1] = ( β - α ) / abi
    b[2] = sqrt( 4*(α+1)*(β+1) / ( (ab+3)*abi*abi ) )
    a2b2 = β*β - α*α
    for i = 2:n
        abi = ab + 2i
        a[i]   = a2b2 / ( (abi-2)*abi )
        b[i+1] = sqrt( 4i*(α+i)*(β+i)*(ab+i) /
                     ( (abi*abi-1)*abi*abi ) )
    end   
    return a, b
end

"""
    x, w = laguerre(n, α, endpt=neither)

Returns points `x` and weights `w` for the `n`-point Gauss-Laguerre rule
for the interval `0 < x < ∞` with weight function

    w(x) = xᵅ exp(-x),   α > -1.

Use `endpt=left` for the left Radau rule.
"""
function laguerre(n::Integer, α::T, 
                  endpt::EndPt=neither) where {T<:AbstractFloat}
    @assert n ≥ 1
    @assert α > -1.0
    @assert endpt in [neither, left]
    a, b = laguerre_coefs(n, α)
    custom_gauss_rule(zero(T), convert(T, Inf), a, b, endpt)
end

function laguerre_coefs(n::Integer, α::T) where {T<:AbstractFloat}
    a = zeros(T, n)
    b = zeros(T, n+1)
    b[1] = sqrt(gamma(α+1))
    for i = 1:n
        a[i] = 2i - 1 + α
        b[i+1] = sqrt( i*(α+i) )
    end
    return a, b
end

"""
    x, w = hermite(T, n)

Returns points `x` and weights `w` for the `n`-point Gauss-Laguerre rule
for the interval `-∞ < x < ∞` with weight function

    w(x) = exp(-x²).
"""
function hermite(::Type{T}, n::Integer) where {T<:AbstractFloat}
    @assert n ≥ 1
    a, b = hermite_coefs(T, n)
    custom_gauss_rule(convert(T, -Inf), convert(T, Inf), a, b, neither)
end

"""
Convenience function with type `T = Float64`:

    x, w = hermite(n)
"""
hermite(n) = hermite(Float64, n)

function hermite_coefs(::Type{T}, n::Integer) where {T<:AbstractFloat}
    a = zeros(T, n)
    b = zeros(T, n+1)
    b[1] = sqrt(sqrt(convert(T, pi)))
    for i = 1:n
        iT = convert(T, i)
        b[i+1] = sqrt(iT/2)
    end
    return a, b
end

"""
    x, w = logweight(T, n, r=0, endpt=neither)

Returns points `x` and weights `w` for the n-point Gauss rule on
the interval `0 < x < 1` with weight function

    w(x) = xʳ log(1/x),    r ≥ 0.
"""
function logweight(::Type{T}, n::Integer, r::Integer, 
                   endpt::EndPt=neither) where {T<:AbstractFloat}
    @assert n ≥ 1
    @assert r ≥ 0
    α, β = logweight_coefs(T, n, r)
    custom_gauss_rule(zero(T), one(T), α, β, endpt)
end

"""
Convenience function with type `T = Float64`:

    x, w = logweight(n, r=0, endpt=neither)
"""
logweight(n, r=0, endpt=neither) = logweight(Float64, n, r, endpt)

"""
More general method works when `w(x) = x^ρ log(1/x)` for real `ρ > -1`:

    x, w = logweight(n, ρ, endpt=neither)
"""
function logweight(n::Integer, ρ::T, 
                   endpt::EndPt=neither) where {T<:AbstractFloat}
    @assert n ≥ 1
    @assert ρ > -1
    α, β = logweight_coefs(n, ρ)
    custom_gauss_rule(zero(T), one(T), α, β, endpt)
end

function logweight_coefs(::Type{T}, n::Integer, 
                         r::Integer) where {T<:AbstractFloat}
    a, b = shifted_legendre_coefs(T, 2n)
    ν = modified_moments(T, n, r)
    α, β, σ = modified_chebyshev(a, b, ν)
    return α, β
end

function logweight_coefs(n::Integer, ρ::T) where {T<:AbstractFloat}
    a, b = shifted_legendre_coefs(T, 2n)
    ν = modified_moments(n, ρ)
    α, β, σ = modified_chebyshev(a, b, ν)
    return α, β
end

function modified_moments(::Type{T}, n::Integer, 
                          r::Integer) where {T<:AbstractFloat}
    @assert r ≥ 0
    @assert n ≥ 0
    m = min(2n, r+1)
    rrp1 = 1 / convert(T, r+1) # reciprocal r+1
    B = one(T)
    S = rrp1
    ν = zeros(T, 2n)
    ν[1] = rrp1 * S
    for l = 2:m
        j = l - 1
	rrpj = 1 / convert(T, r + 1 + j)
        rmj = convert(T, r + 1 - j)
	rrmj = 1 / rmj
        B *= rmj * rrpj
        S +=  rrpj - rrmj
        tlm1 = convert(T, 2l-1)
        ν[l] = rrp1 * B * S * sqrt(tlm1)
    end
    if 2n > r+1
        p = one(T)
        for j = 1:r
            p *= j / convert(T, 2(2j+1))
        end
        ν[r+2] = - sqrt(convert(T, 2r+3)) *p / ( 2(r+1) )
        for l = r+2:2n-1
            Tl = convert(T, l)
            ν[l+1] = - ν[l] * ( (Tl-r-1)/(Tl+r+1) ) * sqrt((2Tl+1)/(2Tl-1) )  
        end
    end
    return ν
end

function modified_moments(n::Integer, ρ::T) where {T<:AbstractFloat}
    @assert ρ > -1 
    @assert n ≥ 0
    r = (ρ<0) ? 0 : round(Integer, ρ)
    m = min(2n, r+1)
    S = 1 / ( 1 + ρ )
    B = one(T)
    ν = zeros(T, 2n)
    ν[1] = S / (1+ρ)
    for l = 2:m
        j = l - 1
        B *= (ρ+1-j) / (ρ+1+j)
	S += 1 / (ρ+1+j) - 1 / (ρ+1-j)
        ν[l] = B * S * sqrt(convert(T,2l-1))
    end
    if 2n > r+1
        l = r + 2
	j = l - 1
	X = ( (ρ-r) / (ρ+r+2) - 1 ) / (ρ+r+2)
        tlm1 = convert(T, 2l-1)
	ν[l] = ( B / (1+ρ) ) * ( X + ( (ρ-r)/(ρ+r+2) ) * S ) * sqrt(tlm1)
        for l = r+3:2n
	    j = l - 1
            B *= (ρ+1-j) / (ρ+1+j)
            S += 1 / (ρ+1+j) - 1 / (ρ+1-j)
        tlm1 = convert(T, 2l-1)
	    ν[l] = ( B / (1+ρ) ) * ( X + ( (ρ-r)/(ρ+r+2) ) * S ) * sqrt(tlm1)
        end
    end
    return ν
end

function shifted_legendre_coefs(T, n)
    a = zeros(T, n)
    b = zeros(T, n+1)
    fill!(a, 1/convert(T,2))
    b[1] = one(T)
    for k = 2:n+1
        b[k] = (k-1) / ( 2 * sqrt( convert(T, (2k-1)*(2k-3)) ) )
    end
    return a, b
end

"""
    x, w = custom_gauss_rule(lo, hi, a, b, endpt, maxits=maxiterations[T])

Generates the points `x` and weights `w` for a Gauss rule with weight
function `w(x)` on the interval `lo < x < hi`.

The arrays `a` and `b` hold the coefficients (as given, for instance, by
`legendre_coeff`) in the three-term recurrence relation for the monic
orthogonal polynomials `p(0,x)`, `p(1,x)`, `p(2,x)`, ... , that is,

    p(k, x) = (x-a[k]) p(k-1, x) - b[k]² p(k-2, x),    k ≥ 1,

where `p(0, x) = 1` and, by convention, `p(-1, x) = 0` with

              hi
    b[1]^2 = ∫  w(x) dx.
             lo

Thus, `p(k, x) = xᵏ + lower degree terms` and
     
     hi
    ∫  p(j, x) p(k, x) w(x) dx = 0 if j ≠ k.
    lo
"""
function custom_gauss_rule(lo::T, hi::T, 
             a::Array{T,1}, b::Array{T,1}, endpt::EndPt, 
             maxits::Integer=maxiterations[T]) where {T<:AbstractFloat}
    n = length(a)
    @assert length(b) == n+1
    if endpt == left 
        if n == 1
            a[1] = lo
        else
            a[n] = solve(n, lo, a, b) * b[n]^2 + lo
        end
    elseif endpt == right
        if n == 1
            a[1] = hi
        else
            a[n] = solve(n, hi, a, b) * b[n]^2 + hi
        end
    elseif endpt == both
        if n == 1 
            error("Must have at least two points for both ends.")
        end 
        g = solve(n, lo, a, b)
        t1 = ( hi - lo ) / ( g - solve(n, hi, a, b) )
        b[n] = sqrt(t1)
        a[n] = lo + g * t1
    end
    w = zero(a)
    special_eigenproblem!(a, b, w, maxits)
    for i = 1:n
        w[i] = (b[1] * w[i])^2
    end
    idx = sortperm(a)
    # Ensure end point values are exact.
    if endpt in (left, both)
        a[idx[1]] = lo
    end
    if endpt in (right, both)
        a[idx[n]] = hi 
    end
    return a[idx], w[idx]
end

"""
    α, β, σ = modified_chebyshev(a, b, ν)

Implements the modified Chebyshev algorithm described in `doc/notes.tex`
and used in `logweight_coefs`.
"""
function modified_chebyshev(a::Vector{T}, b::Vector{T}, 
                            ν::Vector{T}) where {T<:AbstractFloat}
    m = length(ν) 
    @assert m % 2 == 0 && m >= 2
    n = div(m, 2)
    @assert length(a) >= max(1, 2n-1)
    @assert length(b) >= max(1, 2n-1)
    α = zeros(T, n)
    β = zeros(T, n+1)
    β[1] = sqrt(ν[1])
    σ = zeros(T, 2n, n)
    for l = 1:2n
        σ[l,1] = ν[l] / β[1]
    end
    α[1] = a[1] + b[2] * ( σ[2,1] / σ[1,1] )
    if n >= 2
        # handle k=1 separately since we have omitted σ[l,0]=0.
        t = ( 1 + (b[3]/b[2]) * (σ[3,1]/σ[1,1])
                + ( (a[2]-α[1])/b[2] ) * (σ[2,1]/σ[1,1]) )
        if t < 0
            error("modified Chebyshev algorithm failed at k = 1")
        end
        β[2] = b[2] * sqrt(t)
        for l = 1:2n-2
            σ[l+1,2] = ( (b[l+2]/β[2])*σ[l+2,1] 
                       + ((a[l+1]-α[1])/β[2]) * σ[l+1,1]
  	               + (b[l+1]/β[2]) * σ[l,1] )
        end
        α[2] = a[2] + b[3] * (σ[3,2]/σ[2,2]) - β[2] * (σ[2,1]/σ[2,2])
        # general k
        for k = 2:n-1
            t = ( 1 + (b[k+2]/b[k+1]) * (σ[k+2,k]/σ[k,k])
                    + ( (a[k+1]-α[k])/b[k+1] ) * (σ[k+1,k]/σ[k,k])
                    - (β[k]/b[k+1]) * (σ[k+1,k-1]/σ[k,k]) )
            β[k+1] = b[k+1] * sqrt(t)
            if t < 0
                error("modified Chebyshev algorithm failed at k = $k")
            end
            for l = k:2n-k-1
                σ[l+1,k+1] = ( (b[l+2]/β[k+1]) * σ[l+2,k] 
                             + ( (a[l+1]-α[k])/β[k+1] ) * σ[l+1,k]
                             + (b[l+1]/β[k+1]) * σ[l,k] 
                             - (β[k]/β[k+1]) * σ[l+1,k-1] )
            end
	    α[k+1] = ( a[k+1] + b[k+2] * (σ[k+2,k+1]/σ[k+1,k+1]) 
                              - β[k+1] * (σ[k+1,k]/σ[k+1,k+1]) )
        end
    end
    return α, β, σ
end

function solve(n::Integer, shift::T, a::Array{T,1}, 
               b::Array{T,1}) where {T<:AbstractFloat}
    #
    # Perform elimination to find the nth component s = delta[n]
    # of the solution to the nxn linear system
    #
    #     ( J_n - shift I_n ) delta = e_n,
    #
    # where J_n is the symmetric tridiagonal matrix with diagonal
    # entries a[i] and off-diagonal entries b[i], and e_n is the nth
    # standard basis vector.
    #
    t = a[1] - shift
    for i = 2:n-1
        t = a[i] - shift - b[i]^2 / t
    end
    return one(t) / t
end

function special_eigenproblem!(d::Array{T,1}, e::Array{T,1}, z::Array{T,1}, 
                               maxits::Integer) where {T<:AbstractFloat}
    #
    # Finds the eigenvalues and first components of the normalised
    # eigenvectors of a symmetric tridiagonal matrix by the implicit
    # QL method.
    #
    # d[i]   On entry, holds the ith diagonal entry of the matrix. 
    #        On exit, holds the ith eigenvalue.
    #
    # e[i]   On entry, holds the [i,i-1] entry of the matrix for
    #        i = 2, 3, ..., n.  (The value of e[1] is not used.)
    #        On exit, e is overwritten.
    #
    # z[i]   On exit, holds the first component of the ith normalised
    #        eigenvector associated with d[i].
    #
    # maxits The maximum number of QL iterations.
    #
    # Martin and Wilkinson, Numer. Math. 12: 377-383 (1968).
    # Dubrulle, Numer. Math. 15: 450 (1970).
    # Handbook for Automatic Computation, Vol ii, Linear Algebra, 
    #        pp. 241-248, 1971.
    #
    # This is a modified version of the Eispack routine imtql2.
    #
    n = length(z)
    z[1] = one(T) 
    z[2:n] .= zero(T) 
    e[n+1] = zero(T)

    if n == 1 # Nothing to do for a 1x1 matrix.
        return
    end
    for l = 1:n
        for j = 1:maxits
            # Look for small off-diagonal elements.
            m = n
            for i = l:n-1
                if abs(e[i+1]) <= eps(T) * ( abs(d[i]) + abs(d[i+1]) )
                    m = i
                    break   
                end
            end
            p = d[l]
            if m == l
                continue
            end
            if j == maxits
                msg = string("No convergence after ", j, " iterations",
                             " (try increasing maxits)")
                error(msg)
            end
            # Form shift
            g = ( d[l+1] - p ) / ( 2 * e[l+1] )
            r = hypot(g, one(T))
            g = d[m] - p + e[l+1] / ( g + copysign(r, g) )
            s = one(T)
            c = one(T)
            p = zero(T)
            for i = m-1:-1:l
                f = s * e[i+1]
                b = c * e[i+1]
                if abs(f) <  abs(g)
                    s = f / g
                    r = hypot(s, one(T))
                    e[i+2] = g * r
                    c = one(T) / r
                    s *= c
                else
                    c = g / f
                    r = hypot(c, one(T))
                    e[i+2] = f * r
                    s = one(T) / r
                    c *= s
                end 
                g = d[i+1] - p
                r = ( d[i] - g ) * s + 2 * c * b
                p = s * r
                d[i+1] = g + p
                g = c * r - b
                # Form first component of vector.
                f = z[i+1]
                z[i+1] = s * z[i] + c * f
                z[i]   = c * z[i] - s * f
            end # loop over i
            d[l] -= p
            e[l+1] = g
            e[m+1] = zero(T)
        end # loop over j
    end # loop over l
end

function orthonormal_poly(x::AbstractVector{T}, a::AbstractVector{T}, 
                          b::AbstractVector{T}) where {T<:AbstractFloat}
    # p[i,j] = value at x[i] of orthonormal polynomial of degree j-1.
    m = length(x)
    n = length(a)
    p = zeros(T, m, n+1)
    rb1 = one(T) / b[1]
    if n == 0
        for i = 1:m
            p[i,1] = rb1
        end
        return p
    end
    rb2 = one(T) / b[2]
    for i = 1:m
        p[i,1] = rb1
        p[i,2] = rb2 * ( x[i] - a[1] ) * p[i,1]
    end 
    for j = 2:n
        rb = one(T) / b[j+1]
        for i = 1:m
            p[i,j+1] = rb * ( (x[i]-a[j]) * p[i,j]
                              - b[j] * p[i,j-1] )
        end
    end
    return p
end

end

I = π * besseli(0.0, 1.0)
for endpt in [neither, left, right, both]
    x, w = chebyshev(10, 1, endpt)
    Q = sum(w .* exp.(x))
    @test I ≈ Q
end

I = π * besseli(1.0, 1.0)
for endpt in [neither, left, right, both]
    x, w = chebyshev(10, 2, endpt)
    Q = sum(w .* exp.(x))
    @test I ≈ Q
end

using GaussQuadrature
using SpecialFunctions: gamma
using Printf

#T = Float32
T = Float64
#T = BigFloat

println("\nFloating point data type is ", T)
println("\teps = ", eps(T))

npts = Dict( 
    Float32 => Dict(  "Legendre"  => 10, 
                      "Chebyshev" => 10,
                      "Jacobi"    => 10,
                      "Laguerre"  => 10,
                      "Hermite"   => 10,
                      "Logweight" => 10 ),
    Float64 => Dict(  "Legendre"  => 20, 
                      "Chebyshev" => 12,
                      "Jacobi"    => 12,
                      "Laguerre"  => 20,
                      "Hermite"   => 16,
                      "Logweight" => 16 ),
    BigFloat => Dict( "Legendre" => 100, 
                      "Chebyshev" => 60,
                      "Jacobi"    => 60,
                      "Laguerre"  => 600,
                      "Hermite"   => 80,
                      "Logweight" => 70 )
)

const half = one(T) / 2

function variant(endpt)
    if endpt == neither
        return "Default    "
    elseif endpt == left
        return "Left Radau "
    elseif endpt == right
        return "Right Radau"
    elseif endpt == both
        return "Lobatto    "
    else
        error("Unknown endpt")
    end
end

function table(f, rule, name, ans::T, n::Integer, endpts) where {T}
    println("\nTesting ", name, " rule with ", n, " points:")
    for endpt in endpts
        x, w = rule(n, endpt)
        integral = zero(typeof(x[1])) 
        for j = 1:n
            integral += w[j] * f(x[j])
        end
        relerr = ( integral - ans ) / ans
        @printf("\t%s  %12.2e\n", variant(endpt), relerr)
    end
end

Beta(x::T, y::T) where {T} = gamma(x) * gamma(y) / gamma(x+y)

legendrefunc(x::T)  where {T} = one(T) / ( one(T) + x^2 )

jacobifunc(x::T, c::T, alpha::T, beta::T) where {T} = (
             (x+c)^convert(T,-alpha-beta-2) )

jacobiintegral(alpha::T, beta::T, c::T) where {T} = ( 2^(alpha+beta+1)
      * Beta(1+alpha,1+beta) / ( (c-1)^(1+alpha) * (c+1)^(1+beta) ) )

function laguerrefunc(x::T, alpha::T) where {T}
    if x > eps(T)
        r = -expm1(-x) / x
    else
        r = one(T)
    end
    return r^alpha
end

laguerreintegral(alpha::T) where {T} = Beta(one(T), 1+alpha)

hermiteintegral(a::T) where {T} = sqrt(convert(T, pi)) * exp(a^2)

function logweightintegral(::Type{T}) where {T} 
    three = convert(T, 3)
    return (π/three)^2 * 2sqrt(three)
end


endpts = [neither, left, right, both]
table(legendrefunc, (n, endpt) -> legendre(T, n, endpt), 
      "Legendre", convert(T, pi)/2, npts[T]["Legendre"], endpts)

c = convert(T, 3.0)
table(x -> jacobifunc(x, c, -half, -half),
      (n, endpt) -> chebyshev(T, n, 1, endpt), "Chebyshev (kind=1)",
      jacobiintegral(-half, -half, c), npts[T]["Chebyshev"], endpts)

table(x -> jacobifunc(x, c, half, half),
      (n, endpt) -> chebyshev(T, n, 2, endpt), "Chebyshev (kind=2)",
      jacobiintegral(half, half, c), npts[T]["Chebyshev"], endpts)

alpha = convert(T, 2)  / 5
beta  = convert(T, -1) / 5 
table(x -> jacobifunc(x, c, alpha, beta),
      (n, endpt) -> jacobi(n, alpha, beta, endpt), "Jacobi", 
      jacobiintegral(alpha, beta, c), npts[T]["Jacobi"], endpts)

table(x -> laguerrefunc(x, alpha), 
      (n, endpt) -> laguerre(n, alpha, endpt), "Laguerre",
      laguerreintegral(alpha), npts[T]["Laguerre"], [neither, left])

a = convert(T, 6) / 5
table(x -> exp(2*a*x), (n, endpt) -> hermite(T, n), "Hermite",
      hermiteintegral(a), npts[T]["Hermite"], [neither])

half = convert(T, 1//2)
table(x -> (1-x^2)/(1+x^3), (n, endpt) -> logweight(n, -half, endpt), 
      "Logweight", logweightintegral(T), npts[T]["Logweight"], endpts)

I1 = 1 - exp(-1)
f1(x) = (1-x)*exp(-x) # Gradshteyn 4.351(1)

for endpt in [neither, both, left, right]
    x, w = logweight(10, 0, endpt)
    @test I1 ≈ sum(w .* f1.(x))
    x, w = logweight(10, 0.0, endpt)
    @test I1 ≈ sum(w .* f1.(x))
end

I2 = (π/3)^2 * 2 * sqrt(3)
f2(x) = (1-x^2) / (1+x^3) # Gradshteyn 4.255(1), p=3/2, q=3
for endpt in [neither, both, left, right]
    x, w = logweight(10, -1/2, endpt)
    @test I2 ≈ sum(w .* f2.(x))
end

correct = ( pi/4 + atan(3.0) ) / 2
for endpt in [neither, both, left, right]
    x, w = legendre(40, endpt)
    if endpt in [left, both]
        @test x[1] == -1
    end
    if endpt in [right, both]
        @test x[end] == 1
    end
    Q = sum(w .* 1 ./ ( 1 .+ (2x .- 1).^2))
    @test Q ≈ correct
end

# Orthogonality tests

using GaussQuadrature
using Printf

T = BigFloat
#T = Float64
println("\nFloating point type data type is ", T)
println("\teps = ", eps(T))

xlegendre(n, alpha, beta, endpt) = legendre(T, n, endpt)
xchebyshev_first(n, alpha, beta, endpt) = chebyshev(T, n, 1, endpt)
xchebyshev_second(n, alpha, beta, endpt) = chebyshev(T, n, 2, endpt)
xhermite(n, alpha, beta, endpt) = hermite(T, n)
xlaguerre(n, alpha, beta, endpt) = laguerre(n, alpha, endpt)
xlogweight(n, alpha, beta , endpt) = logweight(T, n, 
                                     round(Int64,alpha), endpt)

xlegendre_coefs(n, alpha, beta) = legendre_coefs(T, n)
xchebyshev_first_coefs(n, alpha, beta) = chebyshev_coefs(T, n, 1)
xchebyshev_second_coefs(n, alpha, beta) = chebyshev_coefs(T, n, 2)
xhermite_coefs(n, alpha, beta) = hermite_coefs(T, n)
xlaguerre_coefs(n, alpha, beta) = laguerre_coefs(n, alpha)
xlogweight_coefs(n, alpha, beta) = logweight_coefs(T, n, 
                                   round(Int64,alpha))

rule = [xlegendre, xchebyshev_first, xchebyshev_second, 
        xhermite, jacobi, xlaguerre, xlogweight]

coefs = [ xlegendre_coefs, xchebyshev_first_coefs, 
          xchebyshev_second_coefs, xhermite_coefs, jacobi_coefs, 
          xlaguerre_coefs, xlogweight_coefs ]

name = ["Legendre", "Chebyshev (first)", "Chebyshev (second)",
         "Hermite", "Jacobi", "Laguerre", "Log weight" ]

alpha = one(T)
beta  = one(T)/2
xargs = [(),(1),(2), (), (alpha, beta), (alpha)]

function discrepancy(n, dop, w, p)
    d = 0.0
    for k = 0:dop
        for j = 0:min(k-1, dop-k)
            s = 0.0
            for l = 1:n
                s += w[l] * p[l,j+1] * p[l,k+1]
            end
            d = max(d, abs(s))
        end 
        if 2*k <= dop
            s = 0.0
            for l = 1:n
                s += w[l] * p[l,k+1]^2
            end
            d = max(d, abs(s-1.0))
        end
    end 
    return d
end

function dop(n, endpt)
    if endpt == neither
        return 2*n - 1
    elseif endpt == left || endpt == right
        return 2*n - 2
    else
        return 2*n - 3
    end
end

function test_rule(descr, nmin, nmax, rule, coefs, name, endpt)
    println("\nTesting ", descr, " rules with ", nmin, " to ", 
            nmax, " points")
    for case in zip(rule, coefs, name)
        rulefunc, coeffunc, rulename = case
        maxd = 0.0
        for n = nmin:nmax
            x, w = rulefunc(n, alpha, beta, endpt)
            a, b = coeffunc(2n, alpha, beta)
            p = orthonormal_poly(x, a, b)
            d = discrepancy(n, dop(n, endpt), w, p)
            maxd = max(d, maxd)
        end
        @printf("\t%s: %12.4e\n", rpad(rulename, 20, ' '), maxd)
    end
end

test_rule("plain Gauss", 1, 5, rule, coefs, name, neither)

filter!(x->(x!=xhermite), rule)
filter!(x->(x!=xhermite_coefs), coefs)
filter!(x->(x!="Hermite"), name)

test_rule("left Radau", 1, 5, rule, coefs, name, left)

filter!(x->(x!=xlaguerre), rule)
filter!(x->(x!=xlaguerre_coefs), coefs)
filter!(x->(x!="Laguerre"), name)

test_rule("right Radau", 1, 5, rule, coefs, name, right)
test_rule("Lobatto", 2, 5, rule, coefs, name, both)

using GaussQuadrature
using Printf

T = Float64

println("\nFloating point data type is ", T)
@printf("\teps = %0.2e\n\n", eps(T))

n = 10
d = rand(T, n)
e = rand(T, n)
z = zero(d)

A = SymTridiagonal(d, e[1:end-1])
D, V = eig(A)

steig!(d, e, z, 30)
idx = sortperm(d)
d = d[idx]
z = z[idx]

@printf("\nEigenvalues:\n\n")
@printf("%20s  %20s  %12s\n\n", "eig", "steig!", "difference")
for i=1:length(d)
    @printf("%20.15f  %20.15f  %12.2e\n", d[i], D[i], d[i]-D[i])
end

@printf("\nFirst component of eigenvectors:\n\n")
@printf("%20s  %20s  %12s\n\n", "eig", "steig!", "difference")
for i=1:length(d)
    @printf("%20.15f  %20.15f  %12.2e\n", z[i], V[1,i], 
            abs(z[i])-abs(V[1,i]))
end
